// 3exception.cc -- tda Vector -- s  kontrolou indexu a pednm hodnoty
//                                  indexu ve vjimce

#include <iostream>
using namespace std;

class Vector {
  int *p;
  int sz;
 public:
  enum { max = 32000 }; // konstanta
  struct Range { // tda vjimky
    int index;   // hodnota chybnho indexu
    Range(int i) : index(i) {}
  };
  struct Size {  // tda vjimky
    int size;    // hodnota
    Size(int i) : size(i) {}
  };
  int &operator[] (int i) {
    if(i>=0 && i<sz) return p[i];
    throw Range(i); // pedn hodnoty
  }
  Vector(int size) : p(0), sz(size) {
    if(sz<0 || sz>max) throw Size(sz);
    p = new int[sz];
  }
};

#if 0 // zkuste chybu
void f(Vector &v) nothrow {
#else
void f(Vector &v) {
#endif
    int x = -1;
    v[x] = 5;
}

int main() {
  try {
    Vector v(10);
    f(v); // pouit tdy Vector
  }
  catch(Vector::Range r) {
    cerr << "chybn index: " << r.index << '\n' ;
    // obsluha vjimky  Vector::Range
  }
  catch(Vector::Size s) {
    cerr << "chybn rozmr vektoru: " << s.size << '\n' ;
    // obsluha vjimky  Vector::Size
  }
}



