// ctr2.cc -- konstruktory 2 (konstrukce sloench objekt)
//
// program provdjte po krocch a sledujte poad voln konstruktor
//

#include <iostream>
using namespace std;

struct A {
  A()           { cout << " A()\n"; }
  A(const A &x) { cout << " A(const A&)\n"; }
};

struct B {
  B(int x)      { cout << " B(int)\n"; }
  B(const B &x) { cout << " B(const B&)\n"; }
};

class X { // tda s vnoenmi objekty
  A a;
  B b;    // B nem implicitn konstruktor
 public:
  X() : b(5)    { cout << " X()\n"; }
  X(int x) : b(x) { cout << " X(int)\n"; }
#if 1 // zkuste, jak peklada vytvo "copy" konstruktor
  X(const X &x) : a(x.a), b(x.b) { cout << " X(const X&)\n"; }
#endif
};

int main() {
  cout << "objekt o1:\n" ;
  X o1;         // implicitn konstruktor X::X()
  cout << "objekt o2:\n" ;
  X o2(1);      // X::X(int)
  cout << "objekt o3:\n" ;
  X o3(o1);     // X::X(const X&) -- kopruje

  // destruktory se volaj v opanm poad, mete si je doplnit
  return 0;
}

