//
// fstream1.cc -- soubory
//

#include <fstream>   // fstream, atd
#include <iostream>  // cout

const char *filename = "TMP.$$$";

int main()
{
    char c;
    int i;
    double d;
    char s[100];
    using namespace std;

    fstream fs(filename, ios::out);	// oteven pro zpis
    if (!fs) {
	cout << " Chyba pi otevrn " << filename << "\n";
	return 1;
    }

    fs << 'A' << '\n';
    fs << 123 << '\n';
    fs << 3.14 << '\n';
    fs << "text1  text2\n";
    fs.close();

    fs.open(filename, ios::in);	// oteven pro ten
    if (!fs) {
	cout << " Chyba pi otevrn " << filename << "\n";
	return 1;
    }

    fs >> c >> i >> d >> s;	// ten
    fs.close();

    cout << c << '\n';
    cout << i << '\n';
    cout << d << '\n';
    cout << s << '\n';		// pouze jedno slovo

}
