// stream-redir.cc
// jak pesmrovat streamy
// Zdroj: http://www.cuj.com/experts/1903/hyslop.htm
//

#include <iostream>
#include <fstream>
int main()
{
    std::ofstream logFile("out.txt"); // clov soubor

    std::cout << "Tento text se tiskne na cout \n";
    std::cerr << "Tento text se tiskne na cerr \n";

    // pesmrovn cout:
    std::streambuf *outbuf = std::cout.rdbuf(logFile.rdbuf());
    // pesmrovn cerr:
    std::streambuf *errbuf = std::cerr.rdbuf(logFile.rdbuf());

    // st programu s pesmrovanm vstupem:
    std::cout << "Tento text by bez pesmrovn el na cout \n";
    std::cerr << "Tento text by bez pesmrovn el na cerr \n";
    logFile << "Tento text se vdy zape do clovho souboru \n";

    // obnova pvodnho stavu:
    std::cout.rdbuf(outbuf);
    std::cerr.rdbuf(errbuf);

    std::cout << "Tento text se tiskne na cout \n";
    std::cerr << "Tento text se tiskne na cerr \n";
}
