

// C++20: variadic template + fold expression

#include <iostream>

void print(auto && ... args) {
   (std::cout << ... << args) << '\n';
   std::cout << "N=" << sizeof...(args) << '\n';
   (std::cout << "sizeof=" << ... << sizeof(args)) << '\n';
}

int main() {
   print("aaaaa", 12, 'x', 2020);
}
