
// test of member function reference qualifiers

#include <iostream>

class X {
   int data;
  public:
      X(int x=0): data{x} {}
      // void test()         { std::cout << "\n"; }
#if 1
      void test()       & { std::cout << "non-const lvalue\n"; }
#endif
      void test() const & { std::cout << "lvalue\n"; }
#if 1
      void test()      && { std::cout << "non-const rvalue\n"; }
#endif
};

int main() {
    X a;
    const X b;
    a.test();
    b.test();
    std::move(a).test();
    // warning: a is unusable after move
}
