// abstclass.cc -- abstraktn tdy

class point {                   // tda point obsahuje souadnice
  int x;
  int y;
 public:
  point(int _x, int _y) { x=_x; y=_y; }
  point() { x = 0; y = 0; }
};

class shape {                   // abstraktn tda - obrazec
  point position;
 public:
  point where() { return position; }    // pozice obrazce
  void move(point p) {                  // posun obrazce
    undraw();
    position = p;
    draw();
  }
  virtual void rotate(int) =0;  // oto - ist virtuln fce
  virtual void draw()      =0;  // kresli
  virtual void undraw()    =0;  // vyma
};

shape *sptr;    // ukazatel na abstraktn tdu me bt
//shape s;        // objekty vytvet nelze

class circle : public shape {   // tda - krunice
  int radius;
 public:
  void rotate(int) {} // definice virtuln metody, przdn operace
  void draw() {}
  void undraw() {}
};

class triangle : public shape { // tda - trojhelnk
  point b, c;
 public:
  void rotate(int) {} // definice virtuln metody, doplnit
  void draw() {}
  void undraw() {}
};

int main() {
  circle c1;
  triangle t1;
  point pos(100,100);

  c1.draw();
  t1.draw();

  c1.move(pos);
  t1.rotate(90);

  return 0;
}

