// ctr.cc -- konstruktory 1
//
// program provdjte po krocch
// sledujte poad voln konstruktor

#include <iostream>
using namespace std;

class X {
 public:
  X()           { cout << "X()\n"; }
  X(int x)      { cout << "X(int)\n"; }
// private: // zkuste odpoznmkovat
  X(const X &x) { cout << "X(const X&)\n"; }
};

int main() {
  X o1;         // implicitn konstruktor X::X()
  X o2(1);      // X::X(int)
  X o3 = 1;     // X::X(int) [a X::X(const X&) - optimalizovno]
  X o4(o1);     // X::X(const X&) -- kopruje
  X o5 = o2;    // X::X(const X&)

  cout << "pole:\n";
  // konstruktory pro elementy pol jsou volny v rostoucm poad index
  X array[5];   // 5 * implicitn konstruktor X::X()
}

