// io.cc -- definice vstup/vst. opertor

#include <iostream>
using namespace std;

class Complex { // pokusn tda
  double real, imag;
 public:
  Complex() { real = imag = 0; }
  Complex(double r, double i=0) { real = r; imag = i; }
  double Real() const { return real; }
  double Imag() const { return imag; }
  friend Complex operator +(const Complex c1, const Complex c2) {
    return Complex(c1.real + c2.real, c1.imag + c2.imag);
  }
};


// vstupn opertor pro Complex (nemus bt friend)
ostream& operator << (ostream &s, const Complex &x) {
  return s << '(' << x.Real() << ',' << x.Imag() << ')' ;
}

int main() {
    Complex  a(0,1);
    Complex  b(1,0);
    Complex  c = a + b;

    cout << " a = " << a << endl;
    cout << " b = " << b << endl;
    cout << "-----------" << endl;
    cout << " c = " << c << endl;

    return 0;
}

