// multinh3.cc -- problmy nsobn ddinosti 
//
// pklad vysvtluje, pro pi konverzi ukazatele na objekt
// na ukazatel na virtuln bzovou tdu 
// dojde ke zmn hodnoty ukazatele

#include <iostream>
using namespace std;

class A {
  int a; // data 
 public:
  A(int x): a(x) { 
    cout << "konstruktor A(" << a << ") this = " << this << endl; 
  }
  virtual ~A() { cout << "destruktor  A" << endl;      }
};

class B: public virtual A {
  int b; // data - nepouito
 public:
  B(): A(10) { cout << "konstruktor B() this = " << this << endl; }
  ~B()       { cout << "destruktor  B" << endl;   }
};

int main() {
  B *pb = new B;
  // nsleduj konverze na ukazatele na podobjekty objektu d
  A *pa = pb; // implicitn konverze me mnit hodnotu ukazatele!
  //
  // struktura objektu:
  //
  //  +-------------------------+ <---- pb
  //  | ukazatel na podobjekt A |
  //  +-------------------------+
  //  | data B                  |
  //  +-------------------------+ <---- pa
  //  | zddno z virtuln A   |
  //  +-------------------------+
  //
  cout << "adresa objektu B " << pb << endl;
  cout << "adresa objektu B po konverzi na A* " << pa << endl;
  // delete pa; // CHYBA: nepouiteln pro ruen (neukazuje na cel objekt)
  // delete dynamic_cast<B*>(pa);  // pouiteln po konverzi, 
                                   // (A mus bt polymorfn)
  delete pb;
  return 0;
}
